=== debian/changelog ===
libfido2 (1.10.0-1) unstable; urgency=medium

  * New upstream release.

 -- Colin Watson <cjwatson@debian.org>  Thu, 20 Jan 2022 14:28:29 +0000
