## libfido2 1.11.0

=== debian/changelog ===
libfido2 (1.11.0-1) unstable; urgency=medium

  * New upstream release.
  * Speed up debian/run-regression-tests.sh.

 -- Colin Watson <cjwatson@debian.org>  Wed, 11 May 2022 00:51:00 +0100
