=== debian/changelog ===
libfido2 (1.12.0-2) unstable; urgency=medium

  [ Debian Janitor ]
  * Bump debhelper from old 12 to 13.
  * Set upstream metadata fields: Bug-Database, Bug-Submit,
    Repository-Browse.
  * Update standards version to 4.6.1, no changes needed.
  * Set upstream metadata fields: Repository, Security-Contact.

 -- Colin Watson <cjwatson@debian.org>  Tue, 15 Nov 2022 23:16:25 +0000

libfido2 (1.12.0-1) unstable; urgency=medium

  * New upstream release.
    - hid_linux: reopen hidraw(4) after flock(2) (LP: #1983784).

 -- Colin Watson <cjwatson@debian.org>  Sat, 01 Oct 2022 20:48:17 +0100
