=== debian/control ===
--- 
+++ 
@@ -5,9 +5,9 @@
 Uploaders:
 	Colin Watson <cjwatson@debian.org>,
 	nicoo <nicoo@debian.org>
-Standards-Version: 4.5.0
+Standards-Version: 4.6.1
 Build-Depends:
-	debhelper-compat (= 12),
+	debhelper-compat (= 13),
 	pkg-config,
 	cmake (>= 3.14),
 	mandoc,
