## libfido2 1.13.0

=== debian/changelog ===
libfido2 (1.13.0-1) unstable; urgency=medium

  * Update standards version to 4.6.2, no changes needed.
  * New upstream release.

 -- Colin Watson <cjwatson@debian.org>  Mon, 12 Jun 2023 16:09:42 +0100
