=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Uploaders:
 	Colin Watson <cjwatson@debian.org>,
 	nicoo <nicoo@debian.org>
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Build-Depends:
 	debhelper-compat (= 13),
 	pkg-config,
