=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: libfido2
 Section: libs
 Priority: optional
-Maintainer: Debian Authentication Maintainers <pkg-auth-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Authentication Maintainers <pkg-auth-maintainers@lists.alioth.debian.org>
 Uploaders:
 	Colin Watson <cjwatson@debian.org>,
 	nicoo <nicoo@debian.org>
